## unionfs-fuse 0.21

=== CMakeLists.txt ===
project(unionfs-fuse)

add_subdirectory(src)
add_subdirectory(man)

=== Makefile ===
CFLAGS += -Wall
CPPFLAGS += -D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=26
#CPPFLAGS += -D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=26 -DHAVE_SETXATTR
LDFLAGS += 
DESTDIR?=/usr/local

LIB = -lfuse -lpthread -lm

build:
	make -C src/

clean:
	make -C src/ clean

install: build
	cp src/unionfs $(DESTDIR)/sbin/
	cp man/unionfs-fuse.8 $(DESTDIR)/share/man/man8/

=== src/CMakeLists.txt ===
# Set a default build type for single-configuration
# CMake generators if no build type is set.
IF(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE RelWithDebInfo)
ENDIF(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)

# Select flags.
SET(CMAKE_C_FLAGS "-pipe -W -Wall -DFORTIFY_SOURCE=2")
SET(CMAKE_C_FLAGS_RELWITHDEBINFO "-O2 -g")
SET(CMAKE_C_FLAGS_RELEASE "-O2")
SET(CMAKE_C_FLAGS_DEBUG "-O0 -g")

add_definitions(-D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=26)

option(WITH_XATTR "Enable support for extended attributes")
if(WITH_XATTR)
	add_definitions(-DHAVE_SETXATTR)
endif(WITH_XATTR)

set(HASHTABLE_SRCS hashtable.c hashtable_itr.c)
set(UNIONFS_SRCS unionfs.c stats.c opts.c debug.c findbranch.c readdir.c general.c unlink.c cow.c cow_utils.c string.c rmdir.c)

add_executable(unionfs ${UNIONFS_SRCS} ${HASHTABLE_SRCS})
target_link_libraries(unionfs fuse pthread m rt)

INSTALL(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/unionfs DESTINATION sbin)

=== src/Makefile ===
CFLAGS += -Wall
CPPFLAGS += -D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=26
#CPPFLAGS += -D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=26 -DHAVE_SETXATTR
LDFLAGS += 

LIB = -lfuse -lpthread -lm

HASHTABLE_OBJ = hashtable.o hashtable_itr.o
UNIONFS_OBJ = unionfs.o stats.o opts.o debug.o findbranch.o readdir.o general.o unlink.o rmdir.o cow.o cow_utils.o string.o


unionfs: $(UNIONFS_OBJ) $(HASHTABLE_OBJ)
	$(CC) $(LDFLAGS) -o $@ $(UNIONFS_OBJ) $(HASHTABLE_OBJ) $(LIB)

clean:
	rm -f unionfs
	rm -f *.o

## unionfs-fuse 0.23.hg.20090611

=== src/Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 UNIONFS_OBJ = unionfs.o stats.o opts.o debug.o findbranch.o readdir.o general.o unlink.o rmdir.o cow.o cow_utils.o string.o
 
 
-unionfs: $(UNIONFS_OBJ) $(HASHTABLE_OBJ)
+unionfs: $(UNIONFS_OBJ) $(HASHTABLE_OBJ) version.h
 	$(CC) $(LDFLAGS) -o $@ $(UNIONFS_OBJ) $(HASHTABLE_OBJ) $(LIB)
 
 clean:

## unionfs-fuse 0.24

=== CMakeLists.txt ===
project(unionfs-fuse)

cmake_minimum_required(VERSION 2.0)

# Set a default build type for single-configuration
# CMake generators if no build type is set.
IF(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE RelWithDebInfo)
ENDIF(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)

# Select flags.
SET(CMAKE_C_FLAGS "-pipe -W -Wall -DFORTIFY_SOURCE=2")
SET(CMAKE_C_FLAGS_RELWITHDEBINFO "-O2 -g")
SET(CMAKE_C_FLAGS_RELEASE "-O2")
SET(CMAKE_C_FLAGS_DEBUG "-O0 -g -DDEBUG")

add_definitions(-D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=26)

option(WITH_XATTR "Enable support for extended attributes")
if(WITH_XATTR)
	add_definitions(-DHAVE_SETXATTR)
endif(WITH_XATTR)

add_subdirectory(src)
add_subdirectory(man)

=== Makefile ===
PREFIX=/usr/local
BINDIR=/bin

build:
	$(MAKE) -C src/

clean:
	$(MAKE) -C src/ clean

install: build
	install -d $(DESTDIR)$(PREFIX)$(BINDIR)
	install -m 0755 src/unionfs $(DESTDIR)$(PREFIX)$(BINDIR)
	install -m 0644 man/unionfs-fuse.8 $(DESTDIR)$(PREFIX)/share/man/man8/

=== man/CMakeLists.txt ===
INSTALL(FILES unionfs-fuse.8 DESTINATION share/man/man8/)

=== src/CMakeLists.txt ===
set(HASHTABLE_SRCS hashtable.c hashtable_itr.c)
set(UNIONFS_SRCS unionfs.c stats.c opts.c debug.c findbranch.c readdir.c general.c unlink.c cow.c cow_utils.c string.c rmdir.c)

add_executable(unionfs ${UNIONFS_SRCS} ${HASHTABLE_SRCS})
target_link_libraries(unionfs fuse pthread m rt)

INSTALL(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/unionfs DESTINATION bin)

=== src/Makefile ===
CFLAGS += -Wall
CPPFLAGS += $(shell pkg-config --cflags fuse)
CPPFLAGS += -DFUSE_USE_VERSION=26
#CPPFLAGS += -DHAVE_SETXATTR

LDFLAGS += 

LIB = $(shell pkg-config --libs fuse)
LIB += -lm  # For ceil(3)

HASHTABLE_OBJ = hashtable.o hashtable_itr.o
UNIONFS_OBJ = unionfs.o stats.o opts.o debug.o findbranch.o readdir.o general.o unlink.o rmdir.o cow.o cow_utils.o string.o


unionfs: $(UNIONFS_OBJ) $(HASHTABLE_OBJ) version.h
	$(CC) $(LDFLAGS) -o $@ $(UNIONFS_OBJ) $(HASHTABLE_OBJ) $(LIB)

clean:
	rm -f unionfs
	rm -f *.o

=== debian/changelog ===
unionfs-fuse (0.24-2.2ubuntu1) raring; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/control: Add Multi-Arch: foreign.

 -- Logan Rosen <logatronico@gmail.com>  Thu, 31 Jan 2013 14:25:24 -0500

unionfs-fuse (0.24-2.2) unstable; urgency=low

  * Non-maintainer upload.
  * Depend on fuse instead of fuse-utils. (Closes: #698129)

 -- Ansgar Burchardt <ansgar@debian.org>  Sat, 19 Jan 2013 13:35:47 +0100

unionfs-fuse (0.24-2.1ubuntu1) precise; urgency=low

  * Add Multi-Arch: foreign (LP: #932492)

 -- Scott Ritchie <scottritchie@ubuntu.com>  Tue, 14 Feb 2012 18:43:35 -0800

unionfs-fuse (0.24-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * debian/control: Change Architecture to linux-any as fuse-utils is only
    available there. (Closes: #593697)
  * Remove debian/dirs: /usr/sbin is not used by this package.

 -- Ansgar Burchardt <ansgar@debian.org>  Fri, 29 Apr 2011 23:08:19 +0200

unionfs-fuse (0.24-2) unstable; urgency=low

  * remove quilt dependency and quilt entries from debian/rules
    (Thanks to Martin Pitt for spotting this)
  * Fix debian/changelog, all recent bug numbers had missing '#'
    (Again thanks to Martin) 

 -- Bernd Schubert <bernd.schubert@fastmail.fm>  Tue, 29 Jun 2010 21:28:22 +0200

unionfs-fuse (0.24-1) unstable; urgency=low

  * New upstream release 
  * Add utimens.patch 
  * Also close 509516, although the solution is not perfect yet
    (closes: #509516)
  * Switch to dpkg-source 3.0 (quilt) format

 -- Bernd Schubert <bernd.schubert@fastmail.fm>  Wed, 26 May 2010 16:42:13 +0200

unionfs-fuse (0.23.hg.20100315-1) unstable; urgency=low

  * Another update from my branch to merge with Radek and to 
    update the test script

 -- Bernd Schubert <bernd.schubert@fastmail.fm>  Mon, 15 Mar 2010 00:02:08 +0100

unionfs-fuse (0.23.hg.20090831-1) unstable; urgency=low

  * another pull from my branch
  * fix relative pathes (closes: #541614)
  * inlcude patch from Goswin (closes: #533403)

 -- Bernd Schubert <bernd.schubert@fastmail.fm>  Mon, 31 Aug 2009 00:29:46 +0200

unionfs-fuse (0.23.hg.20090611-1) unstable; urgency=low

  * another pull from my branch
  * change my maintainer mail address

 -- Bernd Schubert <bernd.schubert@fastmail.fm>  Thu, 11 Jun 2009 20:42:41 +0200

unionfs-fuse (0.23.hg.20090601-2) unstable; urgency=low

  * set DH_COMPAT to 7
  * fix several lintian packaging errors

 -- Bernd Schubert <bernd-schubert@gmx.de>  Tue, 02 Jun 2009 00:18:25 +0200

unionfs-fuse (0.23.hg.20090601-1) unstable; urgency=low

  * new upstream release
  * pull from my branch to include everything that is supposed to be in 0.24
    (http://podgorny.cz/~bernd/hg/hgwebdir.cgi/radek-trunk-bernd-merge)
  * (closes: #496794)
  * (closes: #530214)
  * (closes: #511157)
  * new option "-o statfs_omit_ro" (closes: #511446)
  * man page updated if "-o cow" (is not specified closes: #511047)
  * partly fixes bug #509516, I leave that bug open, since only fixed for one
    rw branch

 -- Bernd Schubert <bernd-schubert@gmx.de>  Mon, 01 Jun 2009 23:12:42 +0200

unionfs-fuse (0.21-3) unstable; urgency=high

  * fixes critical buffer overflow on using relativ pathes
  * slightly improve the man page to tell people without -ocow 
    not everything might work as expected
  * change binary path from /usr/sbin to /usr/bin
  * (closes: #511995)
  * (closes: #511158)

 -- Bernd Schubert <bernd-schubert@gmx.de>  Sat, 24 Jan 2009 00:10:44 +0100

unionfs-fuse (0.21-2) unstable; urgency=high

  * fix a critical bug: creating new files in directories existing only
    in read-only branches failed, since the directory path wasn't copied
    to the rw-branch
  * (closes: #495380)

 -- Bernd Schubert <bernd-schubert@gmx.de>  Mon, 11 Aug 2008 09:22:42 +0000

unionfs-fuse (0.21-1) unstable; urgency=low

  * new upstream release

 -- Bernd Schubert <bernd-schubert@gmx.de>  Sat, 26 Jul 2008 18:28:39 +0200

unionfs-fuse (0.20-5) unstable; urgency=low

  * Another pull from my branch, fixes sereveral bugs, among it a critical
    deadlock
  * Installing new NEWS file and examples/ directory with dh_docs
  * This is actually the 0.21 release (also to be released this weekend).

 -- Bernd Schubert <bernd-schubert@gmx.de>  Sat, 26 Jul 2008 14:03:50 +0200

unionfs-fuse (0.20-4) unstable; urgency=low

  * as by suggestion of Kapil:
    - remove debian/copyright.in
    - install the CREDITS file with dh_installdocs

 -- Bernd Schubert <bernd-schubert@gmx.de>  Thu, 26 Jun 2008 21:02:11 +0200

unionfs-fuse (0.20-3) unstable; urgency=low

  * another hg pull from  http://hg.podgorny.cz/unionfs-fuse
    (fixes the elfhash CPL incompatibility problem)
  * Changes to the debian/copyright files as suggested by Kapil Hari Paranjape
    and Richard Laager

 -- Bernd Schubert <bernd-schubert@gmx.de>  Thu, 26 Jun 2008 13:22:14 +0200

unionfs-fuse (0.20-2) unstable; urgency=low

  * add debian/watch file 
  * fix the copyright file generation

 -- Bernd Schubert <bernd-schubert@gmx.de>  Mon, 23 Jun 2008 22:50:03 +0200

unionfs-fuse (0.20-1) unstable; urgency=low

  * Ouch, already so many internal releases and I never noticed the version 
    string was wrong.

 -- Bernd Schubert <bernd-schubert@gmx.de>  Fri, 20 Jun 2008 21:13:18 +0000

unionfs-fuse (0.9.20-2) unstable; urgency=low

  * correct the section to misc

 -- Bernd Schubert <bernd-schubert@gmx.de>  Fri, 20 Jun 2008 12:25:54 +0000

unionfs-fuse (0.9.20-1) unstable; urgency=low

  * new upstream release
  * additional hg pull from
    http://podgorny.cz/~bernd/hg/hgwebdir.cgi/radek-trunk-bernd-merge
  * preparing official debian upload
  * switch to cmake based build system
  * (closes: #481490)

 -- Bernd Schubert <bernd-schubert@gmx.de>  Thu, 19 Jun 2008 17:37:15 +0200

unionfs-fuse (0.9.19-hg20080403-ql2) unstable; urgency=low

  * convert to debian quilt series
  * add fd.patch

 -- Bernd Schubert <bs@q-leap.de>  Tue, 29 Apr 2008 13:56:06 +0200

unionfs-fuse (0.9.19-hg20080403-ql1) unstable; urgency=low



=== debian/control ===
Source: unionfs-fuse
Section: misc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Bernd Schubert <bernd.schubert@fastmail.fm>
Build-Depends: debhelper (>= 7.0.0), libfuse-dev, cmake
Standards-Version: 3.9.0

Package: unionfs-fuse
Architecture: linux-any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, fuse
Description: Fuse implementation of unionfs
 This is another unionfs implementation using filesystem in 
 userspace (fuse).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

CFLAGS = -pipe -W -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	mkdir -p debian/build
	cd debian/build \
	&& cmake ../../ -DCMAKE_INSTALL_PREFIX=/usr \
	                -DCMAKE_C_FLAGS="$(CFLAGS)" \
	                -DCMAKE_SKIP_RPATH=TRUE

	touch configure-stamp


build: build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	cd debian/build && make

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp 

	# Add here commands to clean up after the build process.
	rm -fr debian/build
	rm -f debian/files

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# Add here commands to install the package into debian/unionfsfuse.
	cd debian/build && make DESTDIR=../../debian/unionfs-fuse install

# Build architecture-independent files here.
binary-indep:
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs CREDITS NEWS examples/
	dh_installexamples


#	dh_install
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## unionfs-fuse 1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
-project(unionfs-fuse)
+project(unionfs-fuse C)
 
 cmake_minimum_required(VERSION 2.0)
+INCLUDE (CheckIncludeFiles)
 
 # Set a default build type for single-configuration
 # CMake generators if no build type is set.
@@ -14,12 +15,31 @@
 SET(CMAKE_C_FLAGS_RELEASE "-O2")
 SET(CMAKE_C_FLAGS_DEBUG "-O0 -g -DDEBUG")
 
+if (UNIX AND APPLE)
+  include_directories("/usr/local/include/osxfuse/fuse")
+endif()
+
 add_definitions(-D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=26)
 
-option(WITH_XATTR "Enable support for extended attributes")
-if(WITH_XATTR)
-	add_definitions(-DHAVE_SETXATTR)
-endif(WITH_XATTR)
+option(WITH_XATTR "Enable support for extended attributes" OFF)
+
+# .h include files
+IF (WITH_XATTR)
+	CHECK_INCLUDE_FILES("sys/xattr.h" HAVE_LIBC_XATTR)
+	CHECK_INCLUDE_FILES("attr/xattr.h" HAVE_LIBATTR_XATTR)
+
+	IF (HAVE_LIBC_XATTR)
+		add_definitions(-DLIBC_XATTR)
+	ELSEIF(HAVE_LIBATTR_XATTR)
+		add_definitions(-DLIBATTR_XATTR)
+	ENDIF()
+
+	IF (NOT HAVE_LIBC_XATTR AND NOT HAVE_LIBATTR_XATTR)
+		add_definitions(-DDISABLE_XATTR)
+	ENDIF()
+ELSE (WITH_XATTR)
+	add_definitions(-DDISABLE_XATTR)
+ENDIF (WITH_XATTR)
 
 add_subdirectory(src)
 add_subdirectory(man)

=== Makefile ===
PREFIX=/usr/local
BINDIR=/bin
SBINDIR=/sbin

build:
	$(MAKE) -C src/

clean:
	$(MAKE) -C src/ clean

install: build
	install -d $(DESTDIR)$(PREFIX)$(BINDIR)
	install -d $(DESTDIR)$(PREFIX)$(SBINDIR)
	install -d $(DESTDIR)$(PREFIX)/share/man/man8
	install -m 0755 src/unionfs $(DESTDIR)$(PREFIX)$(BINDIR)
	install -m 0755 src/unionfsctl $(DESTDIR)$(PREFIX)$(BINDIR)
	install -m 0755 mount.unionfs $(DESTDIR)$(PREFIX)$(SBINDIR)
	install -m 0644 man/unionfs.8 $(DESTDIR)$(PREFIX)/share/man/man8/

=== man/CMakeLists.txt ===
INSTALL(FILES unionfs.8 DESTINATION share/man/man8/)

=== src/CMakeLists.txt ===
set(HASHTABLE_SRCS hashtable.c hashtable_itr.c)
set(UNIONFS_SRCS unionfs.c opts.c debug.c findbranch.c readdir.c 
    general.c unlink.c cow.c cow_utils.c string.c rmdir.c usyslog.c)
set(UNIONFSCTL_SRCS unionfsctl.c)

add_executable(unionfs ${UNIONFS_SRCS} ${HASHTABLE_SRCS})

if (UNIX AND NOT APPLE)
    target_link_libraries(unionfs fuse pthread rt)
else()
    target_link_libraries(unionfs fuse pthread)
endif()

add_executable(unionfsctl ${UNIONFSCTL_SRCS})

INSTALL(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/unionfs DESTINATION bin)
INSTALL(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/unionfsctl DESTINATION bin)

=== src/Makefile ===
CFLAGS += -Wall
CPPFLAGS += $(shell pkg-config --cflags fuse)
CPPFLAGS += -DFUSE_USE_VERSION=26

CPPFLAGS += -DLIBC_XATTR # glibc nowadays includes xattr
# CPPFLAGS += -DLIBATTR_XATTR # define this to libattr xattr include

# CPPFLAGS += -DDISABLE_XATTR # disable xattr support
# CPPFLAGS += -DDISABLE_AT    # disable *at function support

LDFLAGS += 

LIB = $(shell pkg-config --libs fuse) -lpthread

HASHTABLE_OBJ = hashtable.o hashtable_itr.o
UNIONFS_OBJ = unionfs.o opts.o debug.o findbranch.o readdir.o \
		general.o unlink.o rmdir.o cow.o cow_utils.o string.o \
		usyslog.o
UNIONFSCTL_OBJ = unionfsctl.o


all: unionfs unionfsctl

unionfs: $(UNIONFS_OBJ) $(HASHTABLE_OBJ) uioctl.h version.h
	$(CC) $(LDFLAGS) -o $@ $(UNIONFS_OBJ) $(HASHTABLE_OBJ) $(LIB)

unionfsctl: $(UNIONFSCTL_OBJ) uioctl.h version.h
	$(CC) $(LDFLAGS) -o $@ $(UNIONFSCTL_OBJ)

clean:
	rm -f unionfs
	rm -f unionfsctl
	rm -f *.o

=== debian/changelog ===
unionfs-fuse (1.0-1ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:27:37 +1100

unionfs-fuse (1.0-1ubuntu3) noble; urgency=high

  * No change rebuild against libfuse2t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:58:07 +0100

unionfs-fuse (1.0-1ubuntu2) bionic; urgency=high

  * No change rebuild to pick up -fPIE compiler default

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 03 Apr 2018 12:48:42 +0000

unionfs-fuse (1.0-1ubuntu1) wily; urgency=medium

  * Merge from Debian unstable (LP: #1476699). Remaining changes:
    - debian/control: Add Multi-Arch: foreign.

 -- Logan Rosen <logan@ubuntu.com>  Sun, 02 Aug 2015 21:46:16 -0400

unionfs-fuse (1.0-1) unstable; urgency=medium

  * New upstream release
  * Fix extended attributes (Closes: #742033)
  * New option for relaxed permissions (-o relaxed_permissions)
    (Closes: #614771)
  * Fix gcc-5 compilation (Closes: #778156)
  * Don't primarily use unionfs-fuse anymore, but just 'unionfs'.
    The name clash I was afraid of never happened, there is no other
    program called unionfs. For debian compatibility create a symlink
    unionfs-fuse -> unionfs
  * lintian fixes (BSD license file, compiler flags)

 -- Bernd Schubert <bernd.schubert@fastmail.fm>  Sun, 12 Jul 2015 20:14:57 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: unionfs-fuse
 Section: misc
 Priority: optional
+Homepage: https://github.com/rpodgorny/unionfs-fuse
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Bernd Schubert <bernd.schubert@fastmail.fm>
-Build-Depends: debhelper (>= 7.0.0), libfuse-dev, cmake
-Standards-Version: 3.9.0
+Build-Depends: debhelper (>= 9.0.0), libfuse-dev, cmake
+Standards-Version: 3.9.6
 
 Package: unionfs-fuse
 Architecture: linux-any

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,14 @@
 # Uncomment this to turn on verbose mode.
 export DH_VERBOSE=1
 
-CFLAGS = -pipe -W -Wall -g
+DPKG_EXPORT_BUILDFLAGS = 1
+include /usr/share/dpkg/buildflags.mk
+CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
+CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
+CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
+LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
+
+CFLAGS += -pipe -W -Wall -g
 
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
 	CFLAGS += -O0
@@ -30,7 +37,11 @@
 	touch configure-stamp
 
 
-build: build-stamp
+build: build-arch build-indep
+
+build-arch: build-stamp
+
+build-indep: build-stamp
 
 build-stamp: configure-stamp 
 	dh_testdir
@@ -59,6 +70,8 @@
 
 	# Add here commands to install the package into debian/unionfsfuse.
 	cd debian/build && make DESTDIR=../../debian/unionfs-fuse install
+	ln -s -r debian/unionfs-fuse/usr/bin/unionfs \
+                 debian/unionfs-fuse/usr/bin/unionfs-fuse
 
 # Build architecture-independent files here.
 binary-indep:
